From 1fcf5d6b962a2533e1bc459a3d43b8b4a0a6a100 Mon Sep 17 00:00:00 2001
From: Niranjan <niranjan@multicorewareinc.com>
Date: Wed, 10 Feb 2021 01:07:39 +0530
Subject: [PATCH] Enable --scenecut-aware-qp with --crf in pass 2

---
 source/encoder/ratecontrol.cpp | 10 ++++++++++
 1 file changed, 10 insertions(+)

diff --git a/source/encoder/ratecontrol.cpp b/source/encoder/ratecontrol.cpp
index a4756de39..9c7b6132b 100644
--- a/source/encoder/ratecontrol.cpp
+++ b/source/encoder/ratecontrol.cpp
@@ -1394,6 +1394,16 @@ int RateControl::rateControlStart(Frame* curFrame, RateControlEntry* rce, Encode
     if (!m_isAbr && m_2pass && m_param->rc.rateControlMode == X265_RC_CRF)
     {
         rce->qpPrev = x265_qScale2qp(rce->qScale);
+        if (m_param->bEnableSceneCutAwareQp)
+        {
+            double lqmin = m_lmin[m_sliceType];
+            double lqmax = m_lmax[m_sliceType];
+            if (m_param->bEnableSceneCutAwareQp & FORWARD)
+                rce->newQScale = forwardMasking(curFrame, rce->newQScale);
+            if (m_param->bEnableSceneCutAwareQp & BACKWARD)
+                rce->newQScale = backwardMasking(curFrame, rce->newQScale);
+            rce->newQScale = x265_clip3(lqmin, lqmax, rce->newQScale);
+        }
         rce->qScale = rce->newQScale;
         rce->qpaRc = curEncData.m_avgQpRc = curEncData.m_avgQpAq = x265_qScale2qp(rce->newQScale);
         m_qp = int(rce->qpaRc + 0.5);
-- 
2.18.0.windows.1

